﻿Public Class Form1

    ' ===================================================================
    '  OPEN CLOSE FORM AND SERIAL PORT
    ' ===================================================================
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Text = AppTitleAndVersion()
        Load_INI()
        SetRawCharsFlag()
        SetCaliperDivision()
        CmbSeparatorInit()
        txt_FirstSlot.Text = FirstSlot.ToString
        OpenComm()
        Timer1.Interval = 100
        Timer1.Start()
        EventsAreEnabled = True
        txt_SendCharacters.Focus()
        rtb_ReceiveMonitor.Cursor = Cursors.Default
    End Sub
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
        COM_Close()
    End Sub

    Private Sub btn_Help_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Help.Click
        Form2.Hide()
        Form2.Show(Me)
    End Sub

    Private Sub OpenComm()
        Dim baudrate As Int32 = CInt(Val(cmb_ComSpeed.Text))
        COM_Open(cmb_ComPort.Text, baudrate)
        UpdateComButton()
    End Sub

    Private Sub UpdateComButton()
        If COM_IsOpen() Then
            btn_Connect.Text = "Disconnect"
            btn_Connect.BackColor = Color.FromArgb(255, 180, 120)
        Else
            btn_Connect.Text = "Connect"
            btn_Connect.BackColor = Color.FromArgb(240, 240, 240)
        End If
    End Sub

    Private Sub btn_Connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Connect.Click
        If COM_IsOpen() Then
            COM_Close()
            UpdateComButton()
        Else
            OpenComm()
        End If
    End Sub

    Private Sub cmb_ComSelection_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ComPort.DropDown
        cmb_ComPort.Items.Clear()
        For Each s As String In COM_GetPortNames()
            cmb_ComPort.Items.Add(s)
        Next
    End Sub

    Private Sub cmb_ComPort_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ComPort.TextChanged
        If Not EventsAreEnabled Then Return
        OpenComm()
    End Sub
    Private Sub cmb_ComPort_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ComPort.DropDownClosed
        btn_Connect.Focus()
    End Sub

    Private Sub cmb_ComSpeed_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles cmb_ComSpeed.KeyDown
        OnlyNumericComboBox(sender, e)
    End Sub
    Private Sub cmb_ComSpeed_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ComSpeed.TextChanged
        If Not EventsAreEnabled Then Return
        OpenComm()
    End Sub
    Private Sub cmb_ComSpeed_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ComSpeed.DropDownClosed
        btn_Connect.Focus()
    End Sub

    Private Sub rtb_ReceiveMonitor_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles rtb_ReceiveMonitor.KeyPress
        Select Case e.KeyChar
            Case Chr(1)
                ' -------------------------------------- CTRL-A
                rtb_ReceiveMonitor.SelectAll()
                e.Handled = True
                ' -------------------------------------- CTRL-C
            Case Chr(3)
                e.Handled = False
            Case Else
                e.Handled = True
        End Select
    End Sub

    Private Sub btn_ClearText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ClearText.Click
        COM_ReceivedText = ""
        rtb_ReceiveMonitor.Text = ""
        COM_DiscardInBuffer()
    End Sub

    Private Sub chk_RawChars_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_RawChars.CheckedChanged
        SetRawCharsFlag()
        'COM_ReceivedText = ""
        COM_Close()
        OpenComm()
    End Sub

    Private Sub SetRawCharsFlag()
        ShowRawChars = chk_RawChars.Checked
        If ShowRawChars Then
            rtb_ReceiveMonitor.WordWrap = True
            GroupBox3.Text = "Decode (disabled)"
            GroupBox3.Enabled = False
        Else
            rtb_ReceiveMonitor.WordWrap = False
            GroupBox3.Text = "Decode to Slots"
            GroupBox3.Enabled = True
        End If
    End Sub

    Private Sub txt_FirstSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_FirstSlot.TextChanged
        FirstSlot = CInt(Val(txt_FirstSlot.Text))
    End Sub


    ' ===================================================================
    '  SEND Characters and Strings
    ' ===================================================================
    Private Sub txt_SendCharacters_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txt_SendCharacters.KeyPress
        COM_SendString(e.KeyChar)
    End Sub

    Private Sub btn_Send_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Send.Click
        Dim s As String
        s = txt_SendString.Text
        If chk_TerminatorCR.Checked Then s += vbCr
        If chk_TerminatorLF.Checked Then s += vbLf
        COM_SendString(s)
    End Sub

    Private Sub txt_CommunicationMonitor_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles txt_SendString.MouseDoubleClick
        COM_ReceivedText = ""
    End Sub

    ' ===================================================================
    '  CMB Separator
    ' ===================================================================
    Private Sub cmb_Separator_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Separator.DropDownClosed
        btn_Connect.Focus()
    End Sub

    Private Sub cmb_Separator_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Separator.SelectedIndexChanged
        Select Case cmb_Separator.Text.ToLower
            Case "space" : FieldSeparator = " "
            Case ";" : FieldSeparator = ";"
            Case "," : FieldSeparator = ","
            Case ":" : FieldSeparator = ":"
            Case "caliper" : FieldSeparator = "0"
            Case "comp1" : FieldSeparator = "1"
            Case "comp2" : FieldSeparator = "2"
        End Select
        If Not EventsAreEnabled Then Return
        SetCaliperDivision()
        COM_Close()
        OpenComm()
    End Sub

    Friend Sub CmbSeparatorInit()
        If FieldSeparator = "" Then FieldSeparator = " "
        Select Case FieldSeparator
            Case " " : cmb_Separator.Text = "Space"
            Case ";" : cmb_Separator.Text = ";"
            Case "," : cmb_Separator.Text = ","
            Case ":" : cmb_Separator.Text = ":"
            Case "0" : cmb_Separator.Text = "Caliper"
            Case "1" : cmb_Separator.Text = "Comp1"
            Case "2" : cmb_Separator.Text = "Comp2"
        End Select
    End Sub

    Private Sub SetCaliperDivision()
        If FieldSeparator = "0" Then
            CaliperDivision = 100
        Else
            CaliperDivision = 1000
        End If
    End Sub


    ' ===================================================================
    '  RTB FUNCTIONS
    ' ===================================================================
    Private Sub ScrollToEndOfText()
        rtb_ReceiveMonitor.SelectionStart = rtb_ReceiveMonitor.TextLength
        rtb_ReceiveMonitor.ScrollToCaret()
    End Sub

    'Private Sub ClearFirstLine()
    '    If rtb_ReceiveMonitor.Lines.Length = 0 Then Return
    '    rtb_ReceiveMonitor.Select(0, rtb_ReceiveMonitor.Lines(0).Length)
    '    rtb_ReceiveMonitor.SelectedText = ""
    'End Sub

    Private AllTheReceivedTextIsVisible As Boolean
    Private Sub ShowAllTheReceivedText()
        If Not AllTheReceivedTextIsVisible Then
            AllTheReceivedTextIsVisible = True
            ' ----------------------------------------------------------- word wrap
            If ShowRawChars Then
                rtb_ReceiveMonitor.WordWrap = True
            Else
                rtb_ReceiveMonitor.WordWrap = False
            End If
            ' ----------------------------------------------------------- use all the text
            rtb_ReceiveMonitor.Text = COM_ReceivedText
            'ClearFirstLine()
            rtb_ReceiveMonitor.ScrollBars = RichTextBoxScrollBars.Both
            ' ----------------------------------------------------------- color (too slow)
            'If chk_RawChars.Checked Then
            '    ColorRawChars()
            'End If
            '
            ScrollToEndOfText()
        End If
    End Sub

    'Private Sub ColorRawChars(ByVal first As Int32)
    '    For i As Int32 = 0 To rtb_ReceiveMonitor.Text.Length - 1
    '        If rtb_ReceiveMonitor.Text(i) = "<" Then
    '            rtb_ReceiveMonitor.SelectionStart = i
    '            rtb_ReceiveMonitor.SelectionLength = 4
    '            rtb_ReceiveMonitor.SelectionBackColor = Color.Yellow
    '        End If
    '    Next
    'End Sub


    ' =========================================================================
    '  ENABLE DISABLE TEXT UPDATE
    ' =========================================================================
    Private TextUpdateEnabled As Boolean
    Private Sub DisableTextUpdate()
        If TextUpdateEnabled Then
            TextUpdateEnabled = False
            grb_ReceiveMonitor.BackColor = Me.BackColor
            rtb_ReceiveMonitor.BackColor = Color.FromArgb(255, 255, 220)
            grb_ReceiveMonitor.Text = "Receive (disabled)"
            ShowAllTheReceivedText()
        End If
    End Sub
    Private Sub EnableTextUpdate()
        If Not TextUpdateEnabled Then
            TextUpdateEnabled = True
            grb_ReceiveMonitor.BackColor = Color.Honeydew
            rtb_ReceiveMonitor.BackColor = Color.White
            grb_ReceiveMonitor.Text = "Receive monitor"
            rtb_ReceiveMonitor.SelectionLength = 0
            rtb_ReceiveMonitor.SelectionStart = rtb_ReceiveMonitor.TextLength
            rtb_ReceiveMonitor.Select()
        End If
    End Sub


    ' =========================================================================
    '  RECEIVE TIMER
    ' =========================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        '
        If Me.WindowState = FormWindowState.Minimized Then
            Return
        End If
        ' --------------------------------------------------------------------- 
        If Not COM_IsOpen() Then
            ShowAllTheReceivedText()
            EnableTextUpdate()
            Return
        End If
        ' ---------------------------------------------------------------------
        If CursorInsideControl(grb_ReceiveMonitor) Then
            DisableTextUpdate()
        Else
            If Not TextUpdateEnabled Then
                If Control.MouseButtons = Windows.Forms.MouseButtons.None Then
                    EnableTextUpdate()
                End If
            End If
        End If
        ' ---------------------------------------------------------------------
        If TextUpdateEnabled Then
            '
            ' ----------------------------------------------------------------- prepare ScrollBars and WordWrap
            If AllTheReceivedTextIsVisible Then
                rtb_ReceiveMonitor.ScrollBars = RichTextBoxScrollBars.None
                rtb_ReceiveMonitor.Refresh()
                AllTheReceivedTextIsVisible = False
                rtb_ReceiveMonitor.WordWrap = True
            Else
                rtb_ReceiveMonitor.WordWrap = False
            End If
            '
            ' ----------------------------------------------------------------- update ComReceivedText
            UpdateComReceivedText()
            If Not ComReceivedTextUpdated Then Return
            ComReceivedTextUpdated = False
            '
            ' ---------------------------------------------------------------- calc visible lines
            'Dim nlines As Int32
            'nlines = rtb_ReceiveMonitor.ClientSize.Height \ _
            '         (rtb_ReceiveMonitor.Font.Height + 1)
            '' ---------------------------------------------------------------- show visible lines
            'Dim n As Int32 = -1
            'For i As Int32 = 1 To nlines
            '    n = Strings.InStrRev(COM_ReceivedText, vbLf, n) - 1
            'Next
            'rtb_ReceiveMonitor.Text = Strings.Mid(COM_ReceivedText, n + 2)


            ' TODO
            rtb_ReceiveMonitor.Text = COM_ReceivedText

            ' ---------------------------------------------------------------- 
            ScrollToEndOfText()

            ' TODO
            'Me.Refresh()

            ' ---------------------------------------------------------------- delete text with Chr(27+2J)
            'If COM_ReceivedText.Contains(Chr(27) + "[2J") AndAlso _
            '                                  Not chk_RawChars.Checked Then
            '    rtb_ReceiveMonitor.Text = ""
            '    COM_ReceivedText = ""
            'End If
            ' -------------------------------------------------------------- DEBUG
            'Text = COM_ReceivedText.Length.ToString
        End If
    End Sub

End Class
